NovaDB Delivery API
Binary Data
Delivery_GetBinary
Get a database binary by id
Request
GET /binaries/{id}
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *id | integer (int32) | The binary id |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The binary has not been modified |
||
| 404 | The binary could not be found |
Delivery_GetExternalBinary
Get an external binary (a file) by name
Request
GET /files/{name}
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *name | string | The file name of the external binary |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The file has not been modified |
||
| 400 | The file name is invalid |
||
| 404 | The file could not be found |
Delivery_GetBpoExternalBinary
Get an external binary (a file) by binary proxy object id
Request
GET /branches/{branch}/files/{id}
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *id | string | The binary proxy object ID or ApiIdentifier |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The file has not been modified |
||
| 404 | The binary proxy could not be found |
||
| 422 | The id is not unique |
Delivery_GetBpoThumbnail
Get a thumbnail by binary proxy object id
Request
GET /branches/{branch}/thumbnails/{id}
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *id | string | The binary proxy object ID or ApiIdentifier |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The thumbnail has not been modified |
||
| 404 | The binary proxy could not be found |
||
| 422 | The id is not unique |
API Configuration
Delivery_GetBranches
Get the indexed branches
Request
GET /branches
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
Delivery_GetLanguages
Get the configured languages (i.e., UI languages, languages indexed for display names, langiages from configuration options and English)
Request
GET /branches/{branch}/config/languages
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The configuration has not been modified |
||
| 404 | The branch could not be found |
Delivery_GetTypes
Get the configured object types
Request
GET /branches/{branch}/config/types
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The configuration has not been modified |
||
| 404 | The branch could not be found |
Delivery_GetUpdateInfo
Get index update information
Request
GET /branches/{branch}/updateInfo
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The index has not been modified |
||
| 404 | The branch could not be found |
Object Data
Delivery_Count
Count objects
Request
GET /branches/{branch}/count[?lang&variants&filter&deleted]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| deleted | boolean | Include deleted objects |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch could not be found |
Delivery_List
Get a list of scoped objects.
Request
GET /branches/{branch}/objects[?lang&variants&resolve&resolveDepth&resolveReverse&resolveReverseDepth&resolveUnits&filter&sort&deleted&props&skip&take]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| resolve | string | A comma separated list of ApiIdentifiers attributes to be resolved and returned in a "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveDepth | integer (int32) | The maximum depth to resolve referred objects |
|
| resolveReverse | string | A comma separated list of ApiIdentifiers attributes to be resolved reverse. IDs of reverse relations are delivered in the "reverse" property and objects are returned in the "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveReverseDepth | integer (int32) | The maximum depth to resolve reverse references |
|
| resolveUnits | boolean | Resolve units of measure |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| sort | string | A comma separated list of attribute IDs or ApiIdentifiers used as sort criteria. 'asc' or 'desc' can be used as an additional keyword to set the sort order. The special value "$score" can also be used for sorting, which sorts by score. The default sort order is by object ID. |
|
| deleted | boolean | Include deleted objects |
|
| props | Mode to show properties (0 = configured by ObjectTypeApiAttributes, 1 = all with API identifiers, 2 = none) |
||
| skip | integer (int32) | Skip a number of items. Must not be negative. |
|
| take | integer (int32) | Take this number of items. Must be in the range 1..1000 |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch could not be found |
Delivery_Get
Get a single scoped object
Request
GET /branches/{branch}/objects/{id}[?lang&variants&resolve&resolveDepth&resolveReverse&resolveReverseDepth&resolveUnits&deleted&props]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *id | string | The object ID or ApiIdentifier |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| resolve | string | A comma separated list of ApiIdentifiers attributes to be resolved and returned in a "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveDepth | integer (int32) | The maximum depth to resolve referred objects |
|
| resolveReverse | string | A comma separated list of ApiIdentifiers attributes to be resolved reverse. IDs of reverse relations are delivered in the "reverse" property and objects are returned in the "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveReverseDepth | integer (int32) | The maximum depth to resolve reverse references |
|
| resolveUnits | boolean | Resolve units of measure |
|
| deleted | boolean | Include deleted object |
|
| props | Mode to show properties (0 = configured by ObjectTypeApiAttributes, 1 = all with API identifiers, 2 = none) |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch or object could not be found |
||
| 422 | The object id is not unique |
Delivery_CountTyped
Count typed objects
Request
GET /branches/{branch}/types/{type}/count[?lang&variants&filter&deleted]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *type | string | The object type ID or ApiIdentifier |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| deleted | boolean | Include deleted objects |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch or type could not be found |
Delivery_ListTyped
Get a list of typed and scoped objects
Request
GET /branches/{branch}/types/{type}/objects[?lang&variants&resolve&resolveDepth&resolveReverse&resolveReverseDepth&filter&sort&resolveUnits&deleted&props&skip&take]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *type | string | The object type ID or ApiIdentifier |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| resolve | string | A comma separated list of ApiIdentifiers attributes to be resolved and returned in a "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveDepth | integer (int32) | The maximum depth to resolve referred objects |
|
| resolveReverse | string | A comma separated list of ApiIdentifiers attributes to be resolved reverse. IDs of reverse relations are delivered in the "reverse" property and objects are returned in the "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveReverseDepth | integer (int32) | The maximum depth to resolve reverse references |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| sort | string | A comma separated list of attribute IDs or ApiIdentifiers used as sort criteria. 'asc' or 'desc' can be used as an additional keyword to set the sort order. The special value "$score" can also be used for sorting, which sorts by score. The default sort order is by object ID. |
|
| resolveUnits | boolean | Resolve units of measure |
|
| deleted | boolean | Include deleted objects |
|
| props | Mode to show properties (0 = configured by ObjectTypeApiAttributes, 1 = all with API identifiers, 2 = none) |
||
| skip | integer (int32) | Skip a number of items. Must not be negative. |
|
| take | integer (int32) | Take this number of items. Must be in the range 1..1000 |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch or type could not be found |
Delivery_GetTyped
Get a single typed and scoped object
Request
GET /branches/{branch}/types/{type}/objects/{id}[?lang&variants&resolve&resolveDepth&resolveReverse&resolveReverseDepth&resolveUnits&deleted&props]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *type | string | The object type as an ID or ApiIdentifier |
|
| *id | string | The object ID or ApiIdentifier |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| resolve | string | A comma separated list of ApiIdentifiers attributes to be resolved and returned in a "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveDepth | integer (int32) | The maximum depth to resolve referred objects |
|
| resolveReverse | string | A comma separated list of ApiIdentifiers attributes to be resolved reverse. IDs of reverse relations are delivered in the "reverse" property and objects are returned in the "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveReverseDepth | integer (int32) | The maximum depth to resolve reverse references |
|
| resolveUnits | boolean | Resolve units of measure |
|
| deleted | boolean | Include deleted object |
|
| props | Mode to show properties (0 = configured by ObjectTypeApiAttributes, 1 = all with API identifiers, 2 = none) |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch, type or object could not be found |
||
| 422 | The id is not unique |
Occurrences
Delivery_Occurrences
Get occurrences for a list of fields that may be used for facet filtering
Request
GET /branches/{branch}/occurrences?fields[&lang&variants&filter&resolve&resolveDepth&deleted&props&take]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *fields | string | A comma separated list of field names |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| resolve | string | A comma separated list of ApiIdentifiers attributes to be resolved and returned in a "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveDepth | integer (int32) | The maximum depth to resolve referred objects |
|
| deleted | boolean | Include deleted objects |
|
| props | Mode to show properties (0 = configured by ObjectTypeApiAttributes, 1 = all with API identifiers, 2 = none) |
||
| take | integer (int32) | Take this number of items. Must be in the range 1..1000 |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch could not be found |
Delivery_OccurrencesTyped
Get occurrences for a particular object type and a list of fields that may be used for facet filtering.
Request
GET /branches/{branch}/types/{type}/occurrences?fields[&lang&variants&filter&resolve&resolveDepth&deleted&props&take]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *type | string | The object type ID or ApiIdentifier |
|
| *fields | string | A comma separated list of field names |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| resolve | string | A comma separated list of ApiIdentifiers attributes to be resolved and returned in a "refs" list. Wrong ApiIdentifiers are ignored. |
|
| resolveDepth | integer (int32) | The maximum depth to resolve referred objects |
|
| deleted | boolean | Include deleted objects |
|
| props | Mode to show properties (0 = configured by ObjectTypeApiAttributes, 1 = all with API identifiers, 2 = none) |
||
| take | integer (int32) | Take this number of items. Must be in the range 1..1000 |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch or type could not be found |
Suggestions
Delivery_Suggestions
Get a list of suggestions for a search pattern that may be used for type-ahead
Request
GET /branches/{branch}/suggestions?pattern&fields[&lang&variants&filter&deleted&take&sortByValue&analyze&fuzzy&fuzzyMinSimilarity&fuzzyPrefixLength]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *pattern | string | The search pattern |
|
| *fields | string | A comma separated list of field names |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| deleted | boolean | Include deleted objects |
|
| take | integer (int32) | Take this number of items. Must be in the range 1..1000 |
|
| sortByValue | boolean | If true, suggestions are sorted by value and not by count |
|
| analyze | boolean | If true, the search pattern is analyzed, otherwise it must occur as a prefix. |
|
| fuzzy | boolean | If true, the last search term is used as a fuzzy pattern, not as a prefix. |
|
| fuzzyMinSimilarity | number (float) | Minimum similarity for fuzzy search. The default value is 0.5. If fuzzy=false, this value is ignored |
|
| fuzzyPrefixLength | integer (int32) | The prefix length for fuzzy search. The default value is 0. If fuzzy=false, this value is ignored |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch could not be found |
Delivery_SuggestionsTyped
Get a list of suggestions for a search pattern and a particular object type that may be used for type-ahead
Request
GET /branches/{branch}/types/{type}/suggestions?pattern&fields[&lang&variants&filter&deleted&take&sortByValue&analyze&fuzzy&fuzzyMinSimilarity&fuzzyPrefixLength]
Parameters
| Name | Type | Default | Notes |
|---|---|---|---|
| *branch | string | The branch ID or ApiIdentifier |
|
| *type | string | The object type ID or ApiIdentifier |
|
| *pattern | string | The search pattern |
|
| *fields | string | A comma separated list of field names |
|
| lang | string | The localization language as an ID or a culture name |
|
| variants | string | A comma separated list of variant IDs or ApiIdentifiers |
|
| filter | string | A list of filter conditions joined with the AND operator '&&'. A condition is build from an ApiIdentifier, a compare operator (=, !=, <, >, <=, >=, :) and a value. Prefix with 'meta.' to access meta data. |
|
| deleted | boolean | Include deleted objects |
|
| take | integer (int32) | Take this number of items. Must be in the range 1..1000 |
|
| sortByValue | boolean | If true, suggestions are sorted by value and not by count |
|
| analyze | boolean | If true, the search pattern is analyzed, otherwise it must occur as a prefix. |
|
| fuzzy | boolean | If true, the last search term is used as a fuzzy pattern, not as a prefix. |
|
| fuzzyMinSimilarity | number (float) | Minimum similarity for fuzzy search. The default value is 0.5. If fuzzy=false, this value is ignored |
|
| fuzzyPrefixLength | integer (int32) | The prefix length for fuzzy search. The default value is 0. If fuzzy=false, this value is ignored |
Responses
| Status Code | Type | Description | Samples |
|---|---|---|---|
| 200 | OK |
||
| 304 | The content has not been modified |
||
| 400 | Bad request parameter |
||
| 404 | The branch or type could not be found |